/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         parserparse
#define yylex           parserlex
#define yyerror         parsererror
#define yydebug         parserdebug
#define yynerrs         parsernerrs

#define yylval          parserlval
#define yychar          parserchar
#define yylloc          parserlloc

/* Copy the first part of user declarations.  */
#line 29 "src/parser.y" /* yacc.c:339  */


#include <sys/types.h>
#include <sys/stat.h>
#ifdef _MSC_VER
#define strdup _strdup
#else
#include <unistd.h>
#endif

#include "FileModule.h"
#include "UserModule.h"
#include "ModuleInstantiation.h"
#include "Assignment.h"
#include "expression.h"
#include "value.h"
#include "function.h"
#include "printutils.h"
#include "memory.h"
#include <sstream>
#include <stack>
#include <boost/filesystem.hpp>
#include "boost-utils.h"
#include "feature.h"

namespace fs = boost::filesystem;

#define YYMAXDEPTH 20000
#define LOC(loc) Location(loc.first_line, loc.first_column, loc.last_line, loc.last_column, sourcefile())
#ifdef DEBUG
static Location debug_location(const std::string& info, const struct YYLTYPE& loc);
#define LOCD(str, loc) debug_location(str, loc)
#else
#define LOCD(str, loc) LOC(loc)
#endif

int parser_error_pos = -1;

int parserlex(void);
void yyerror(char const *s);

int lexerget_lineno(void);
bool lexer_is_main_file();
std::shared_ptr<fs::path> sourcefile(void);
void lexer_set_parser_sourcefile(const fs::path& path);
int lexerlex_destroy(void);
int lexerlex(void);
static void handle_assignment(const std::string token, Expression *expr, const Location loc);

std::stack<LocalScope *> scope_stack;
FileModule *rootmodule;

extern void lexerdestroy();
extern FILE *lexerin;
const char *parser_input_buffer;
static fs::path mainFilePath;
static bool parsingMainFile;
static std::string sourcefile_folder;

bool fileEnded=false;

#line 137 "objects/parser.cxx" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "parser.hxx".  */
#ifndef YY_PARSER_OBJECTS_PARSER_HXX_INCLUDED
# define YY_PARSER_OBJECTS_PARSER_HXX_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int parserdebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ERROR = 258,
    TOK_EOT = 259,
    TOK_MODULE = 260,
    TOK_FUNCTION = 261,
    TOK_IF = 262,
    TOK_ELSE = 263,
    TOK_FOR = 264,
    TOK_LET = 265,
    TOK_ASSERT = 266,
    TOK_ECHO = 267,
    TOK_EACH = 268,
    TOK_ID = 269,
    TOK_STRING = 270,
    TOK_USE = 271,
    TOK_NUMBER = 272,
    TOK_TRUE = 273,
    TOK_FALSE = 274,
    TOK_UNDEF = 275,
    LE = 276,
    GE = 277,
    EQ = 278,
    NE = 279,
    AND = 280,
    OR = 281,
    NO_ELSE = 282
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 99 "src/parser.y" /* yacc.c:355  */

  char *text;
  double number;
  class Value *value;
  class Expression *expr;
  class Vector *vec;
  class ModuleInstantiation *inst;
  class IfElseModuleInstantiation *ifelse;
  class Assignment *arg;
  AssignmentList *args;

#line 217 "objects/parser.cxx" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE parserlval;
extern YYLTYPE parserlloc;
int parserparse (void);

#endif /* !YY_PARSER_OBJECTS_PARSER_HXX_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 248 "objects/parser.cxx" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   412

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  50
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  37
/* YYNRULES -- Number of rules.  */
#define YYNRULES  113
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  226

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   282

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,    35,     2,    36,     2,     2,
      31,    32,    37,    42,    49,    43,    48,    44,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    39,    28,
      41,    33,    40,    38,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,    47,    45,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    29,     2,    30,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   173,   173,   175,   181,   185,   186,   187,   191,   193,
     192,   206,   214,   220,   222,   226,   234,   239,   244,   249,
     255,   254,   264,   271,   276,   275,   288,   287,   299,   301,
     302,   306,   307,   308,   316,   317,   318,   319,   320,   321,
     325,   334,   335,   340,   344,   349,   354,   362,   363,   370,
     371,   378,   379,   383,   390,   391,   395,   399,   403,   410,
     411,   415,   422,   423,   427,   431,   439,   440,   444,   448,
     455,   456,   463,   464,   469,   473,   481,   485,   489,   493,
     497,   502,   507,   511,   515,   519,   523,   531,   534,   543,
     548,   552,   565,   571,   575,   583,   584,   591,   592,   595,
     597,   601,   606,   611,   620,   623,   628,   636,   641,   650,
     653,   658,   666,   670
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ERROR", "TOK_EOT", "TOK_MODULE",
  "TOK_FUNCTION", "TOK_IF", "TOK_ELSE", "TOK_FOR", "TOK_LET", "TOK_ASSERT",
  "TOK_ECHO", "TOK_EACH", "TOK_ID", "TOK_STRING", "TOK_USE", "TOK_NUMBER",
  "TOK_TRUE", "TOK_FALSE", "TOK_UNDEF", "LE", "GE", "EQ", "NE", "AND",
  "OR", "NO_ELSE", "';'", "'{'", "'}'", "'('", "')'", "'='", "'!'", "'#'",
  "'%'", "'*'", "'?'", "':'", "'>'", "'<'", "'+'", "'-'", "'/'", "'^'",
  "'['", "']'", "'.'", "','", "$accept", "input", "statement", "$@1",
  "inner_input", "assignment", "module_instantiation", "@2",
  "ifelse_statement", "$@3", "if_statement", "@4", "child_statements",
  "child_statement", "module_id", "single_module_instantiation", "expr",
  "logic_or", "logic_and", "equality", "comparison", "addition",
  "multiplication", "unary", "exponent", "call", "primary",
  "expr_or_empty", "list_comprehension_elements",
  "list_comprehension_elements_p", "list_comprehension_elements_or_expr",
  "optional_commas", "vector_expr", "arguments_decl", "argument_decl",
  "arguments_call", "argument_call", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,    59,   123,
     125,    40,    41,    61,    33,    35,    37,    42,    63,    58,
      62,    60,    43,    45,    47,    94,    91,    93,    46,    44
};
# endif

#define YYPACT_NINF -154

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-154)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -154,   312,  -154,  -154,    13,    27,    26,  -154,  -154,  -154,
    -154,  -154,    14,  -154,  -154,   325,   256,   256,   256,   256,
    -154,  -154,  -154,  -154,    54,    52,  -154,    55,    62,   230,
     230,   325,    59,  -154,  -154,  -154,  -154,  -154,  -154,   268,
     365,    83,    83,    68,    69,    74,    75,  -154,  -154,  -154,
    -154,  -154,  -154,   230,   349,   349,   349,   112,    76,    16,
      84,    58,     4,   -22,    41,  -154,  -154,    -8,  -154,    85,
    -154,  -154,   365,    78,  -154,   -13,  -154,  -154,  -154,  -154,
    -154,    79,    65,  -154,    65,    83,   268,   268,   268,    88,
    -154,  -154,  -154,    97,   102,   103,   174,    66,    96,  -154,
      89,    90,  -154,   349,   230,   349,   349,   349,   349,   349,
     349,   349,   349,   349,   349,   349,   349,   268,   349,   230,
     123,  -154,  -154,   230,  -154,    66,   375,   230,    66,   109,
     110,    65,    -3,     0,    11,  -154,   230,   268,   268,   212,
    -154,  -154,  -154,  -154,  -154,   230,  -154,    66,    98,   365,
      84,   105,    58,     4,     4,   -22,   -22,   -22,   -22,    41,
      41,  -154,  -154,  -154,    19,  -154,   100,  -154,  -154,   268,
    -154,  -154,  -154,  -154,    83,  -154,   115,   120,   230,   230,
     230,   121,   -10,    20,   124,    40,   174,  -154,  -154,   230,
    -154,  -154,  -154,  -154,   325,   230,   230,  -154,  -154,  -154,
    -154,   174,   230,   174,   174,  -154,   230,  -154,  -154,  -154,
    -154,   131,  -154,   154,   135,  -154,  -154,   117,  -154,   174,
     268,  -154,  -154,    21,   174,  -154
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,    12,     0,     0,     0,    35,    36,    37,
      38,    39,    34,     3,     5,    13,     0,     0,     0,     0,
       4,     8,     7,    22,    23,     0,    20,     0,     0,     0,
       0,    13,     0,    34,    16,    17,    18,    19,    24,   109,
       0,   104,   104,     0,     0,     0,     0,    81,    80,    79,
      76,    77,    78,     0,     0,     0,     0,    99,     0,    41,
      47,    49,    51,    54,    59,    62,    66,    70,    72,     0,
      14,     6,     0,    81,   112,     0,   110,    31,    28,    33,
      21,   107,    99,   105,    99,   104,   109,   109,   109,     0,
      69,    67,    68,     0,     0,     0,     0,    99,   101,   102,
       0,    99,    26,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   109,     0,     0,
       0,    15,    25,     0,    40,    99,     0,     0,    99,     0,
       0,    99,     0,     0,     0,    82,     0,   109,   109,     0,
      98,    95,    97,    90,   100,     0,    85,    99,     0,     0,
      48,     0,    50,    52,    53,    58,    56,    55,    57,    60,
      61,    65,    63,    64,     0,    71,     0,    75,   113,     0,
      32,    30,    29,   108,   100,     9,     0,     0,     0,    87,
      87,     0,     0,     0,     0,     0,   100,    86,    27,     0,
      73,    74,   111,   106,     0,     0,     0,    44,    88,    45,
      46,     0,     0,     0,     0,    96,     0,    83,   103,    43,
      10,     0,    42,    93,     0,    91,    89,     0,    11,     0,
     109,    84,    94,     0,     0,    92
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -154,  -154,     2,  -154,   134,    42,    -9,  -154,  -154,  -154,
    -154,  -154,  -154,   -61,  -154,  -154,   -29,  -154,    67,    64,
     -15,    -7,   -17,   -42,  -154,  -154,  -154,    -4,   -55,   -33,
    -153,   -67,  -154,   -26,     5,   -82,     9
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    31,   194,    32,    21,    22,    40,    23,    72,
      24,   149,   126,    80,    25,    26,    74,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,   199,   141,   142,
     143,   100,   101,    82,    83,    75,    76
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      58,    69,    99,    20,   132,   133,   134,    34,    35,    36,
      37,   122,    90,    91,    92,   129,    84,   130,   202,   124,
     112,   113,   203,   117,    89,   108,   109,    27,    98,   178,
     144,    79,   179,   208,   148,   164,   125,   118,   119,   125,
     120,    28,   103,   180,   110,   111,   125,    30,   213,   125,
     215,   190,   204,   224,   104,   182,   183,    29,   169,   131,
     125,   174,    38,    79,   177,   172,   222,   140,   125,   125,
     125,   225,   161,   162,   163,   151,   165,   114,   115,   206,
     186,   106,   107,    39,   184,   116,    41,   207,   188,    71,
     166,   153,   154,    42,   168,   159,   160,    81,   173,    85,
      86,   155,   156,   157,   158,    87,    88,   181,   102,   105,
      89,   123,   127,   121,   128,    97,   185,    79,    43,    93,
     135,    94,    95,    45,    46,    96,    47,    48,   136,    49,
      50,    51,    52,   137,   138,   145,   146,   167,   223,   147,
      79,   175,   176,    53,   189,   187,    54,   191,   195,   197,
     198,   198,   196,   201,    55,    56,   205,   140,    57,   218,
     209,    97,   219,   220,   221,    70,   211,   212,   171,   152,
     150,   216,   140,   214,   140,   197,   200,   217,   192,   193,
      43,    93,     0,    94,    95,    45,    46,    96,    47,    48,
     140,    49,    50,    51,    52,   140,   210,     0,     0,     0,
       0,     0,     0,     0,     0,   139,     0,     0,    54,     0,
       0,     0,     0,     0,     0,     0,    55,    56,    43,    93,
      57,    94,    95,    45,    46,    96,    47,    48,     0,    49,
      50,    51,    52,     0,     0,     0,    43,     0,     0,     0,
      44,    45,    46,    53,    47,    48,    54,    49,    50,    51,
      52,     0,     0,     0,    55,    56,     0,     0,    57,     0,
       0,    53,     0,     6,    54,     7,     8,     9,    10,    11,
      33,     0,    55,    56,    43,     0,    57,     0,    44,    45,
      46,     0,    73,    48,     0,    49,    50,    51,    52,     0,
      16,    17,    18,    19,     0,     0,     0,     0,     0,    53,
       0,     0,    54,     0,     0,     0,     0,     0,     0,     0,
      55,    56,     2,     0,    57,     0,     3,     4,     5,     6,
       0,     7,     8,     9,    10,    11,    12,     0,    13,     3,
       4,     5,     6,     0,     7,     8,     9,    10,    11,    12,
      14,    15,     0,     0,     0,     0,    16,    17,    18,    19,
       0,     0,     0,    14,    15,     0,     0,     0,     0,    16,
      17,    18,    19,    47,    48,     0,    49,    50,    51,    52,
       0,     0,     6,     0,     7,     8,     9,    10,    11,    33,
      53,     0,     6,    54,     7,     8,     9,    10,    11,    12,
       0,    55,    56,    77,    78,    57,     0,     0,     0,    16,
      17,    18,    19,    77,    78,   170,     0,     0,     0,    16,
      17,    18,    19
};

static const yytype_int16 yycheck[] =
{
      29,    30,    57,     1,    86,    87,    88,    16,    17,    18,
      19,    72,    54,    55,    56,    82,    42,    84,    28,    32,
      42,    43,    32,    31,    53,    21,    22,    14,    57,    32,
      97,    40,    32,   186,   101,   117,    49,    45,    46,    49,
      48,    14,    26,    32,    40,    41,    49,    33,   201,    49,
     203,    32,    32,    32,    38,   137,   138,    31,   125,    85,
      49,   128,     8,    72,   131,   126,   219,    96,    49,    49,
      49,   224,   114,   115,   116,   104,   118,    36,    37,    39,
     147,    23,    24,    31,   139,    44,    31,    47,   149,    30,
     119,   106,   107,    31,   123,   112,   113,    14,   127,    31,
      31,   108,   109,   110,   111,    31,    31,   136,    32,    25,
     139,    33,    33,    28,    49,    49,   145,   126,     6,     7,
      32,     9,    10,    11,    12,    13,    14,    15,    31,    17,
      18,    19,    20,    31,    31,    39,    47,    14,   220,    49,
     149,    32,    32,    31,    39,    47,    34,    47,    33,   178,
     179,   180,    32,    32,    42,    43,    32,   186,    46,    28,
     189,    49,     8,    28,    47,    31,   195,   196,   126,   105,
     103,   204,   201,   202,   203,   204,   180,   206,   169,   174,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
     219,    17,    18,    19,    20,   224,   194,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,    43,     6,     7,
      46,     9,    10,    11,    12,    13,    14,    15,    -1,    17,
      18,    19,    20,    -1,    -1,    -1,     6,    -1,    -1,    -1,
      10,    11,    12,    31,    14,    15,    34,    17,    18,    19,
      20,    -1,    -1,    -1,    42,    43,    -1,    -1,    46,    -1,
      -1,    31,    -1,     7,    34,     9,    10,    11,    12,    13,
      14,    -1,    42,    43,     6,    -1,    46,    -1,    10,    11,
      12,    -1,    14,    15,    -1,    17,    18,    19,    20,    -1,
      34,    35,    36,    37,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      42,    43,     0,    -1,    46,    -1,     4,     5,     6,     7,
      -1,     9,    10,    11,    12,    13,    14,    -1,    16,     4,
       5,     6,     7,    -1,     9,    10,    11,    12,    13,    14,
      28,    29,    -1,    -1,    -1,    -1,    34,    35,    36,    37,
      -1,    -1,    -1,    28,    29,    -1,    -1,    -1,    -1,    34,
      35,    36,    37,    14,    15,    -1,    17,    18,    19,    20,
      -1,    -1,     7,    -1,     9,    10,    11,    12,    13,    14,
      31,    -1,     7,    34,     9,    10,    11,    12,    13,    14,
      -1,    42,    43,    28,    29,    46,    -1,    -1,    -1,    34,
      35,    36,    37,    28,    29,    30,    -1,    -1,    -1,    34,
      35,    36,    37
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    51,     0,     4,     5,     6,     7,     9,    10,    11,
      12,    13,    14,    16,    28,    29,    34,    35,    36,    37,
      52,    55,    56,    58,    60,    64,    65,    14,    14,    31,
      33,    52,    54,    14,    56,    56,    56,    56,     8,    31,
      57,    31,    31,     6,    10,    11,    12,    14,    15,    17,
      18,    19,    20,    31,    34,    42,    43,    46,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    66,
      54,    30,    59,    14,    66,    85,    86,    28,    29,    56,
      63,    14,    83,    84,    83,    31,    31,    31,    31,    66,
      73,    73,    73,     7,     9,    10,    13,    49,    66,    78,
      81,    82,    32,    26,    38,    25,    23,    24,    21,    22,
      40,    41,    42,    43,    36,    37,    44,    31,    45,    46,
      48,    28,    63,    33,    32,    49,    62,    33,    49,    81,
      81,    83,    85,    85,    85,    32,    31,    31,    31,    31,
      66,    78,    79,    80,    81,    39,    47,    49,    81,    61,
      68,    66,    69,    70,    70,    71,    71,    71,    71,    72,
      72,    73,    73,    73,    85,    73,    66,    14,    66,    81,
      30,    55,    63,    66,    81,    32,    32,    81,    32,    32,
      32,    66,    85,    85,    78,    66,    81,    47,    63,    39,
      32,    47,    86,    84,    53,    33,    32,    66,    66,    77,
      77,    32,    28,    32,    32,    32,    39,    47,    80,    66,
      52,    66,    66,    80,    66,    80,    79,    66,    28,     8,
      28,    47,    80,    85,    32,    80
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    50,    51,    51,    51,    52,    52,    52,    52,    53,
      52,    52,    52,    54,    54,    55,    56,    56,    56,    56,
      57,    56,    56,    58,    59,    58,    61,    60,    62,    62,
      62,    63,    63,    63,    64,    64,    64,    64,    64,    64,
      65,    66,    66,    66,    66,    66,    66,    67,    67,    68,
      68,    69,    69,    69,    70,    70,    70,    70,    70,    71,
      71,    71,    72,    72,    72,    72,    73,    73,    73,    73,
      74,    74,    75,    75,    75,    75,    76,    76,    76,    76,
      76,    76,    76,    76,    76,    76,    76,    77,    77,    78,
      78,    78,    78,    78,    78,    79,    79,    80,    80,    81,
      81,    82,    82,    82,    83,    83,    83,    84,    84,    85,
      85,    85,    86,    86
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     1,     3,     1,     1,     0,
       8,     9,     1,     0,     2,     4,     2,     2,     2,     2,
       0,     3,     1,     1,     0,     4,     0,     6,     0,     2,
       2,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       4,     1,     6,     5,     5,     5,     5,     1,     3,     1,
       3,     1,     3,     3,     1,     3,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     3,     1,     2,     2,     2,
       1,     3,     1,     4,     4,     3,     1,     1,     1,     1,
       1,     1,     3,     5,     7,     3,     4,     0,     1,     5,
       2,     5,     9,     5,     7,     1,     3,     1,     1,     0,
       2,     1,     1,     4,     0,     1,     4,     1,     3,     0,
       1,     4,     1,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

/* User initialization code.  */
#line 92 "src/parser.y" /* yacc.c:1429  */
{
  yylloc.first_line = 1;
  yylloc.first_column = 1;
  yylloc.last_column = 1;
  yylloc.last_line = 1;
}

#line 1438 "objects/parser.cxx" /* yacc.c:1429  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 177 "src/parser.y" /* yacc.c:1646  */
    {
              rootmodule->registerUse(std::string((yyvsp[0].text)), lexer_is_main_file() && parsingMainFile ? LOC((yylsp[0])) : Location::NONE);
              free((yyvsp[0].text));
            }
#line 1630 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 7:
#line 188 "src/parser.y" /* yacc.c:1646  */
    {
              if ((yyvsp[0].inst)) scope_stack.top()->addChild(shared_ptr<ModuleInstantiation>((yyvsp[0].inst)));
            }
#line 1638 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 9:
#line 193 "src/parser.y" /* yacc.c:1646  */
    {
              UserModule *newmodule = new UserModule((yyvsp[-4].text), LOCD("module", (yyloc)));
              newmodule->definition_arguments = *(yyvsp[-2].args);
              auto top = scope_stack.top();
              scope_stack.push(&newmodule->scope);
              top->addChild(shared_ptr<UserModule>(newmodule));
              free((yyvsp[-4].text));
              delete (yyvsp[-2].args);
            }
#line 1652 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 10:
#line 203 "src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.pop();
            }
#line 1660 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 11:
#line 207 "src/parser.y" /* yacc.c:1646  */
    {
              scope_stack.top()->addChild(
                make_shared<UserFunction>((yyvsp[-7].text), *(yyvsp[-5].args), shared_ptr<Expression>((yyvsp[-1].expr)), LOCD("function", (yyloc)))
              );
              free((yyvsp[-7].text));
              delete (yyvsp[-5].args);
            }
#line 1672 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 12:
#line 215 "src/parser.y" /* yacc.c:1646  */
    {
                fileEnded=true;
            }
#line 1680 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 15:
#line 227 "src/parser.y" /* yacc.c:1646  */
    {
                handle_assignment((yyvsp[-3].text), (yyvsp[-1].expr), LOCD("assignment", (yyloc)));
                free((yyvsp[-3].text));
            }
#line 1689 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 16:
#line 235 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_root = true;
            }
#line 1698 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 17:
#line 240 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_highlight = true;
            }
#line 1707 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 18:
#line 245 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].inst);
                if ((yyval.inst)) (yyval.inst)->tag_background = true;
            }
#line 1716 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 19:
#line 250 "src/parser.y" /* yacc.c:1646  */
    {
                delete (yyvsp[0].inst);
                (yyval.inst) = NULL;
            }
#line 1725 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 20:
#line 255 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].inst);
                scope_stack.push(&(yyvsp[0].inst)->scope);
            }
#line 1734 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 21:
#line 260 "src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.pop();
                (yyval.inst) = (yyvsp[-1].inst);
            }
#line 1743 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 22:
#line 265 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = (yyvsp[0].ifelse);
            }
#line 1751 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 23:
#line 272 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.ifelse) = (yyvsp[0].ifelse);
            }
#line 1759 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 24:
#line 276 "src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.push((yyvsp[-1].ifelse)->makeElseScope());
            }
#line 1767 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 25:
#line 280 "src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-3].ifelse);
            }
#line 1776 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 26:
#line 288 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.ifelse) = new IfElseModuleInstantiation(shared_ptr<Expression>((yyvsp[-1].expr)), sourcefile_folder, LOCD("if", (yyloc)));
                scope_stack.push(&(yyval.ifelse)->scope);
            }
#line 1785 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 27:
#line 293 "src/parser.y" /* yacc.c:1646  */
    {
                scope_stack.pop();
                (yyval.ifelse) = (yyvsp[-1].ifelse);
            }
#line 1794 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 33:
#line 309 "src/parser.y" /* yacc.c:1646  */
    {
                if ((yyvsp[0].inst)) scope_stack.top()->addChild(shared_ptr<ModuleInstantiation>((yyvsp[0].inst)));
            }
#line 1802 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 34:
#line 316 "src/parser.y" /* yacc.c:1646  */
    { (yyval.text) = (yyvsp[0].text); }
#line 1808 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 35:
#line 317 "src/parser.y" /* yacc.c:1646  */
    { (yyval.text) = strdup("for"); }
#line 1814 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 36:
#line 318 "src/parser.y" /* yacc.c:1646  */
    { (yyval.text) = strdup("let"); }
#line 1820 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 37:
#line 319 "src/parser.y" /* yacc.c:1646  */
    { (yyval.text) = strdup("assert"); }
#line 1826 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 38:
#line 320 "src/parser.y" /* yacc.c:1646  */
    { (yyval.text) = strdup("echo"); }
#line 1832 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 39:
#line 321 "src/parser.y" /* yacc.c:1646  */
    { (yyval.text) = strdup("each"); }
#line 1838 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 40:
#line 326 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.inst) = new ModuleInstantiation((yyvsp[-3].text), *(yyvsp[-1].args), sourcefile_folder, LOCD("modulecall", (yyloc)));
                free((yyvsp[-3].text));
                delete (yyvsp[-1].args);
            }
#line 1848 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 42:
#line 336 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new FunctionDefinition((yyvsp[0].expr), *(yyvsp[-3].args), LOCD("anonfunc", (yyloc)));
              delete (yyvsp[-3].args);
            }
#line 1857 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 43:
#line 341 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new TernaryOp((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), LOCD("ternary", (yyloc)));
            }
#line 1865 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 44:
#line 345 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = FunctionCall::create("let", *(yyvsp[-2].args), (yyvsp[0].expr), LOCD("let", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1874 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 45:
#line 350 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = FunctionCall::create("assert", *(yyvsp[-2].args), (yyvsp[0].expr), LOCD("assert", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1883 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 46:
#line 355 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = FunctionCall::create("echo", *(yyvsp[-2].args), (yyvsp[0].expr), LOCD("echo", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 1892 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 48:
#line 364 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LogicalOr, (yyvsp[0].expr), LOCD("or", (yyloc)));
            }
#line 1900 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 50:
#line 372 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LogicalAnd, (yyvsp[0].expr), LOCD("and", (yyloc)));
            }
#line 1908 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 52:
#line 380 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Equal, (yyvsp[0].expr), LOCD("equal", (yyloc)));
            }
#line 1916 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 53:
#line 384 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::NotEqual, (yyvsp[0].expr), LOCD("notequal", (yyloc)));
            }
#line 1924 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 55:
#line 392 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Greater, (yyvsp[0].expr), LOCD("greater", (yyloc)));
            }
#line 1932 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 56:
#line 396 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::GreaterEqual, (yyvsp[0].expr), LOCD("greaterequal", (yyloc)));
            }
#line 1940 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 57:
#line 400 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Less, (yyvsp[0].expr), LOCD("less", (yyloc)));
            }
#line 1948 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 58:
#line 404 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::LessEqual, (yyvsp[0].expr), LOCD("lessequal", (yyloc)));
            }
#line 1956 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 60:
#line 412 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Plus, (yyvsp[0].expr), LOCD("addition", (yyloc)));
            }
#line 1964 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 61:
#line 416 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Minus, (yyvsp[0].expr), LOCD("subtraction", (yyloc)));
            }
#line 1972 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 63:
#line 424 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Multiply, (yyvsp[0].expr), LOCD("multiply", (yyloc)));
            }
#line 1980 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 64:
#line 428 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Divide, (yyvsp[0].expr), LOCD("divide", (yyloc)));
            }
#line 1988 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 65:
#line 432 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Modulo, (yyvsp[0].expr), LOCD("modulo", (yyloc)));
            }
#line 1996 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 67:
#line 441 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = (yyvsp[0].expr);
            }
#line 2004 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 68:
#line 445 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new UnaryOp(UnaryOp::Op::Negate, (yyvsp[0].expr), LOCD("negate", (yyloc)));
            }
#line 2012 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 69:
#line 449 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new UnaryOp(UnaryOp::Op::Not, (yyvsp[0].expr), LOCD("not", (yyloc)));
            }
#line 2020 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 71:
#line 457 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new BinaryOp((yyvsp[-2].expr), BinaryOp::Op::Exponent, (yyvsp[0].expr), LOCD("exponent", (yyloc)));
           }
#line 2028 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 73:
#line 465 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new FunctionCall((yyvsp[-3].expr), *(yyvsp[-1].args), LOCD("functioncall", (yyloc)));
              delete (yyvsp[-1].args);
            }
#line 2037 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 74:
#line 470 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new ArrayLookup((yyvsp[-3].expr), (yyvsp[-1].expr), LOCD("index", (yyloc)));
            }
#line 2045 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 75:
#line 474 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new MemberLookup((yyvsp[-2].expr), (yyvsp[0].text), LOCD("member", (yyloc)));
              free((yyvsp[0].text));
            }
#line 2054 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 76:
#line 482 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new Literal(true, LOCD("literal", (yyloc)));
            }
#line 2062 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 77:
#line 486 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new Literal(false, LOCD("literal", (yyloc)));
            }
#line 2070 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 78:
#line 490 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new Literal(Value::undefined.clone(), LOCD("literal", (yyloc)));
            }
#line 2078 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 79:
#line 494 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new Literal(Value((yyvsp[0].number)), LOCD("literal", (yyloc)));
            }
#line 2086 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 80:
#line 498 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new Literal(Value(std::string((yyvsp[0].text))), LOCD("string", (yyloc)));
              free((yyvsp[0].text));
            }
#line 2095 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 81:
#line 503 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new Lookup((yyvsp[0].text), LOCD("variable", (yyloc)));
              free((yyvsp[0].text));
            }
#line 2104 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 82:
#line 508 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = (yyvsp[-1].expr);
            }
#line 2112 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 83:
#line 512 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new Range((yyvsp[-3].expr), (yyvsp[-1].expr), LOCD("range", (yyloc)));
            }
#line 2120 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 84:
#line 516 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new Range((yyvsp[-5].expr), (yyvsp[-3].expr), (yyvsp[-1].expr), LOCD("range", (yyloc)));
            }
#line 2128 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 85:
#line 520 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new Literal(VectorType::Empty(), LOCD("vector", (yyloc)));
            }
#line 2136 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 86:
#line 524 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = (yyvsp[-2].vec);
            }
#line 2144 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 87:
#line 531 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = NULL;
            }
#line 2152 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 88:
#line 535 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = (yyvsp[0].expr);
            }
#line 2160 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 89:
#line 544 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new LcLet(*(yyvsp[-2].args), (yyvsp[0].expr), LOCD("lclet", (yyloc)));
              delete (yyvsp[-2].args);
            }
#line 2169 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 90:
#line 549 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new LcEach((yyvsp[0].expr), LOCD("lceach", (yyloc)));
            }
#line 2177 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 91:
#line 553 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = (yyvsp[0].expr);

                /* transform for(i=...,j=...) -> for(i=...) for(j=...) */
                for (int i = (yyvsp[-2].args)->size()-1; i >= 0; i--) {
                  AssignmentList arglist;
                  arglist.push_back((*(yyvsp[-2].args))[i]);
                  Expression *e = new LcFor(arglist, (yyval.expr), LOCD("lcfor", (yyloc)));
                    (yyval.expr) = e;
                }
                delete (yyvsp[-2].args);
            }
#line 2194 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 92:
#line 566 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new LcForC(*(yyvsp[-6].args), *(yyvsp[-2].args), (yyvsp[-4].expr), (yyvsp[0].expr), LOCD("lcforc", (yyloc)));
                delete (yyvsp[-6].args);
                delete (yyvsp[-2].args);
            }
#line 2204 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 93:
#line 572 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new LcIf((yyvsp[-2].expr), (yyvsp[0].expr), 0, LOCD("lcif", (yyloc)));
            }
#line 2212 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 94:
#line 576 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.expr) = new LcIf((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), LOCD("lcifelse", (yyloc)));
            }
#line 2220 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 96:
#line 585 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.expr) = (yyvsp[-1].expr);
            }
#line 2228 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 101:
#line 602 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.vec) = new Vector(LOCD("vector", (yyloc)));
              (yyval.vec)->emplace_back((yyvsp[0].expr));
            }
#line 2237 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 102:
#line 607 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.vec) = new Vector(LOCD("vector", (yyloc)));
              (yyval.vec)->emplace_back((yyvsp[0].expr));
            }
#line 2246 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 103:
#line 612 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.vec) = (yyvsp[-3].vec);
              (yyval.vec)->emplace_back((yyvsp[0].expr));
            }
#line 2255 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 104:
#line 620 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = new AssignmentList();
            }
#line 2263 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 105:
#line 624 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = new AssignmentList();
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2272 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 106:
#line 629 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = (yyvsp[-3].args);
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2281 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 107:
#line 637 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.arg) = new Assignment((yyvsp[0].text), LOCD("assignment", (yyloc)));
                free((yyvsp[0].text));
            }
#line 2290 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 108:
#line 642 "src/parser.y" /* yacc.c:1646  */
    {
              (yyval.arg) = new Assignment((yyvsp[-2].text), shared_ptr<Expression>((yyvsp[0].expr)), LOCD("assignment", (yyloc)));
                free((yyvsp[-2].text));
            }
#line 2299 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 109:
#line 650 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = new AssignmentList();
            }
#line 2307 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 110:
#line 654 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = new AssignmentList();
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2316 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 111:
#line 659 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.args) = (yyvsp[-3].args);
                (yyval.args)->emplace_back((yyvsp[0].arg));
            }
#line 2325 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 112:
#line 667 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.arg) = new Assignment("", shared_ptr<Expression>((yyvsp[0].expr)), LOCD("argumentcall", (yyloc)));
            }
#line 2333 "objects/parser.cxx" /* yacc.c:1646  */
    break;

  case 113:
#line 671 "src/parser.y" /* yacc.c:1646  */
    {
                (yyval.arg) = new Assignment((yyvsp[-2].text), shared_ptr<Expression>((yyvsp[0].expr)), LOCD("argumentcall", (yyloc)));
                free((yyvsp[-2].text));
            }
#line 2342 "objects/parser.cxx" /* yacc.c:1646  */
    break;


#line 2346 "objects/parser.cxx" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 677 "src/parser.y" /* yacc.c:1906  */


int parserlex(void)
{
  return lexerlex();
}

void yyerror (char const *s)
{
  // FIXME: We leak memory on parser errors...
	Location loc = Location(lexerget_lineno(), -1, -1, -1, sourcefile());
	LOG(message_group::Error, loc, "", "Parser error: %1$s", s);
}

#ifdef DEBUG
static Location debug_location(const std::string& info, const YYLTYPE& loc)
{
	auto location = LOC(loc);
	PRINTDB("%3d, %3d - %3d, %3d | %s", loc.first_line % loc.first_column % loc.last_line % loc.last_column % info);
	return location;
}
#endif

static void warn_reassignment(const Location& loc, const shared_ptr<Assignment>& assignment, const fs::path& path)
{
	LOG(message_group::Warning,
			loc,
			path.parent_path().generic_string(),
			"%1$s was assigned on line %2$i but was overwritten",
			assignment->getName(),
			assignment->location().firstLine());

}

static void warn_reassignment(const Location& loc, const shared_ptr<Assignment>& assignment, const fs::path& path1, const fs::path& path2)
{
	LOG(message_group::Warning,
			loc,
			path1.parent_path().generic_string(),
			"%1$s was assigned on line %2$i of %3$s but was overwritten",
			assignment->getName(),
			assignment->location().firstLine(),
			path2);
}

void handle_assignment(const std::string token, Expression *expr, const Location loc)
{
	bool found = false;
	for (auto &assignment : scope_stack.top()->assignments) {
		if (assignment->getName() == token) {
			auto mainFile = mainFilePath.string();
			auto prevFile = assignment->location().fileName();
			auto currFile = loc.fileName();

			const auto uncPathCurr = boostfs_uncomplete(currFile, mainFilePath.parent_path());
			const auto uncPathPrev = boostfs_uncomplete(prevFile, mainFilePath.parent_path());
			if (fileEnded) {
				//assignments via commandline
			} else if (prevFile == mainFile && currFile == mainFile) {
				//both assignments in the mainFile
				warn_reassignment(loc, assignment, mainFilePath);
			} else if (uncPathCurr == uncPathPrev) {
				//assignment overwritten within the same file
				//the line number being equal happens, when a file is included multiple times
				if (assignment->location().firstLine() != loc.firstLine()) {
					warn_reassignment(loc, assignment, mainFilePath, uncPathPrev);
				}
			} else if (prevFile == mainFile && currFile != mainFile) {
				//assignment from the mainFile overwritten by an include
				warn_reassignment(loc, assignment, mainFilePath, uncPathPrev);
			}
			assignment->setExpr(shared_ptr<Expression>(expr));
			assignment->setLocation(loc);
			found = true;
			break;
		}
	}
	if (!found) {
		scope_stack.top()->addChild(assignment(token, shared_ptr<Expression>(expr), loc));
	}
}

bool parse(FileModule *&module, const std::string& text, const std::string &filename, const std::string &mainFile, int debug)
{
  fs::path filepath = fs::absolute(fs::path(filename));
  mainFilePath = fs::absolute(fs::path(mainFile));
  parsingMainFile = mainFilePath == filepath;

  fs::path parser_sourcefile = fs::path(filepath).generic_string();
  sourcefile_folder = parser_sourcefile.parent_path().string();
  lexer_set_parser_sourcefile(parser_sourcefile);

  lexerin = NULL;
  parser_error_pos = -1;
  parser_input_buffer = text.c_str();
  fileEnded = false;

  rootmodule = new FileModule(sourcefile_folder, parser_sourcefile.filename().string());
  scope_stack.push(&rootmodule->scope);
  //        PRINTB_NOCACHE("New module: %s %p", "root" % rootmodule);

  parserdebug = debug;
  int parserretval = -1;
  try{
     parserretval = parserparse();
  }catch (const HardWarningException &e) {
    yyerror("stop on first warning");
  }

  lexerdestroy();
  lexerlex_destroy();

  module = rootmodule;
  if (parserretval != 0) return false;

  parser_error_pos = -1;
  parser_input_buffer = nullptr;
  scope_stack.pop();

  return true;
}
